
var Downloader = function(){

	var persist;
	
	this.getContents = function(){
		var fileUri =  Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService).newFileURI(this.file);
		dump("file: " + this.file.path + " uri: " + fileUri.spec + "\n");
		return getContents(fileUri.spec);
	}
	
	this.getFile = function(){
		return this.file;
	}

	this.download = function(uri, h){
		this.handler = h;
		var file = getTempFile();
		this.file = file;
		var ioservice = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
		var sourceUri = ioservice.newURI(uri, null, null);
		persist=Components.classes["@mozilla.org/embedding/browser/nsWebBrowserPersist;1"].createInstance(Components.interfaces.nsIWebBrowserPersist);
		persist.persistFlags = Components.interfaces.nsIWebBrowserPersist.PERSIST_FLAGS_BYPASS_CACHE;
		var progressListener= new DownloadPersistListener(this, persist);
		persist.progressListener = progressListener;
		persist.saveURI(sourceUri, null, null, null, null,  file);
		
		return progressListener;
	}

	this.cancelDownload = function(){
		persist.cancelSave();
	}

}

function DownloadPersistListener(par, pers){
	this.par = par;
	this.persist = pers;
	this.curProgress = -1;
	this.maxProgress = -1;
	this.curSpeed = -1;
	this.avgSpeed= 0;
	this.eta = Number.POSITIVE_INFINITY;
	this.startTime = Date.now();
	this.lastTime = Date.now();
	//dump("DPL created\n");
	//loggify(this, "DownloadPersistListener");
};
	
DownloadPersistListener.prototype = {

	QueryInterface : function(aIID){
		if(aIID.equals(Components.interfaces.nsIWebProgressListener))
			return this;
		throw Components.results.NS_NOINTERFACE;
	},
 
	init : function()  {},
	destroy : function()  { },
	onProgressChange : function (aWebProgress, aRequest,
                              aCurSelfProgress, aMaxSelfProgress,
                                aCurTotalProgress, aMaxTotalProgress)   {  
				//dump("onProgressChange " + this);
				var recentProgress = aCurTotalProgress - this.curProgress;
				var recentTime = Date.now()- this.lastTime;
				this.curSpeed = (recentProgress/recentTime);
				
				var elapsedTime = Date.now() - this.startTime;
				this.avgSpeed = (aCurTotalProgress/elapsedTime);
				
				this.eta = Date.now() + ((aMaxTotalProgress-aCurTotalProgress)/this.avgSpeed);
				
				this.curProgress = aCurTotalProgress;
				this.maxProgress = aMaxTotalProgress;
				this.lastTime = Date.now();
	},
   
	onStateChange : function(aWebProgress, aRequest, aStateFlags, aStatus)   {
			
		if(aStateFlags & Components.interfaces.nsIWebProgressListener.STATE_STOP){
			if(aStatus==0){
				this.par.handler();
			}else{
				dump("error completing download");
				this.par.handler();
			}
			
		}
		
	},
	onLocationChange : function(aWebProgress, aRequest, aLocation)  {  },
 
	onStatusChange : function(aWebProgress, aRequest, aStatus, aMessage)   {  },
 
	onSecurityChange : function(aWebProgress, aRequest, aState)  {   }
};	

