
dump("Podcache started \n");

var Mefeedia = function(){
	const appSvc = Components.classes["@mozilla.org/appshell/appShellService;1"].getService(Components.interfaces.nsIAppShellService);
	const window = appSvc.hiddenDOMWindow;
	const DOWNLOAD_TIMEOUT = 60000;
	const DOWNLOAD_MAX_SIZE = 100000000;
		
	this.init = function(){
		dump("Mefeedia initialised\n");
		this.config = new Config();
		setPrivileges();
		this.downloadQueue= new DownloadQueue();
		this.cache = new Cache(this.config); 
		this.injector = new ScriptInjector(this);
		this.doSync();
	};
	
	this.doSync = function(){
		dump("Synchronising...\n");
		var downloader = new Downloader();
		this.downloader = downloader;
		downloader.download(this.config.rssUrl, GM_hitch(this, "onSync"));
	}
	
	this.onSync = function(){
		dump("Sync response received\n");
		var responseText = this.downloader.getContents();
		var parser = Components.classes["@mozilla.org/xmlextras/domparser;1"].createInstance(Components.interfaces.nsIDOMParser);
		
		var doc  = parser.parseFromString(responseText, "application/xml");
		//var enclosures = doc.evaluate("//enclosure", doc, null, XPathResult.ANY_TYPE, null);
		var enclosures = doc.evaluate("//media:content", doc, new NSResolver(), Components.interfaces.nsIDOMXPathResult.ANY_TYPE, null);
		//dump("Found "+enclosures.numberValue + " enclosures\n");
		var enc = enclosures.iterateNext();
		var newkeys = new Array();
		while(enc){
			var encUrl = enc.getAttribute("url");
			var encId = doc.evaluate("../guid/text()", enc, null, Components.interfaces.nsIDOMXPathResult.STRING_TYPE, null).stringValue;
			//dump("URL ("+encId + ") " + encUrl + "\n");
			newkeys.push(encId);
			this.downloadQueue.add(encId, encUrl);
			var enc = enclosures.iterateNext();
		}
		this.cache.clearOldkeys(newkeys);
		this.processQueue();
	}
	
	
	this.processQueue = function(){
		var nextDownload = this.downloadQueue.remove();
		this.cache.clean();
		if(!nextDownload){ this.onFinished(); return; }
		var key = nextDownload.id;
		if(this.cache.get(key)){
			dump(key + " already downloaded, skipping	\n"); 
			this.processQueue();
			return;
		}
		dump("Downloading " + key + " from " + nextDownload.url);
		this.currentDownload = key;
		this.currentDownloadProgress = this.downloader.download(nextDownload.url, GM_hitch(this, "onDownload", key));
		this.progressWatcher = window.setInterval(GM_hitch(this, "onProgress"), 2000);
	}
	
	this.onProgress = function(){
		var elapsed = (Date.now() - this.currentDownloadProgress.startTime);
		if(elapsed > DOWNLOAD_TIMEOUT && this.currentDownloadProgress.curProgress == -1){
			//Download stalled
			//abort
			
		}
		if(this.currentDownloadProgress.maxProgress > DOWNLOAD_MAX_SIZE){
			//download too big
			//abort
		}
		//dump("Progress after " + (Date.now() - this.currentDownloadProgress.startTime) + "s : " + this.currentDownloadProgress.curProgress + "/" + this.currentDownloadProgress.maxProgress + "\n");
		//dump("Downloading @ " + this.currentDownloadProgress.curSpeed + " average: " + (this.currentDownloadProgress.curProgress/(Date.now() - this.currentDownloadProgress.startTime)) + "\n");
	}
	
	this.onFinished = function(){
		this.syncTimer = window.setTimeout(GM_hitch(this, "doSync"), 60000);
	}
	
	this.onDownload = function(key){
		window.clearInterval(this.progressWatcher);
		this.currentDownload = null;
		this.currentDownloadProgress = null;
		var file = this.downloader.getFile();
		this.addToCache(file, key);
		this.processQueue();
	}
	
	this.chromeLoad = function(win){
		dump("browser window loaded \n ");
		this.appContent = win.document.getElementById("appcontent"); 
		dump("appcontent: " + this.appContent);
		GM_listen(this.appContent, "DOMContentLoaded", GM_hitch(this.injector, "contentLoad"));
	}
	
	this.chromeUnload = function(){
		dump("Window closing..\n");
		window.clearTimeout(this.syncTimer);
		window.clearInterval(this.progressWatcher);
		//this.cache.clear();
	}


	this.addToCache = function(file, key){
		dump("Added "+key+" to cache\n");
		this.cache.add(file, key);
	}
	
	
	var NSResolver = function(){
	};

	NSResolver.prototype.lookupNamespaceURI = function (prefix) {
		var xmlns = new Object();
		xmlns["content"] = "http://purl.org/rss/1.0/modules/content/";
		xmlns["wfw"] = "http://wellformedweb.org/CommentAPI/"
		xmlns["media"]="http://search.yahoo.com/mrss";
		xmlns["itunes"]="http://www.itunes.com/DTDs/Podcast-1.0.dtd";
		xmlns["creativeCommons"]="http://backend.userland.com/creativeCommonsRssModule";
		xmlns["feedburner"]="http://rssnamespace.org/feedburner/ext/1.0";
		xmlns["rss"]="http://backend.userland.com/rss2";
		xmlns_ =  "http://backend.userland.com/rss2"
		
		if(prefix==""){
			return xmlns_;
		}else{
			return xmlns[prefix];
		}
	};
		
};
