//Most of this was borrowed from Greasemonkey - http://greasemonkey.mozdev.org/

function GM_listen(source, event, listener, opt_capture) {
  Components.lookupMethod(source, "addEventListener").apply(
    source, [event, listener, opt_capture]);
}

function GM_hitch(obj, meth) {
  if (!obj[meth]) {
    throw "method '" + meth + "' does not exist on object '" + obj + "'";
  }
  
  var staticArgs = Array.prototype.splice.call(arguments, 2, arguments.length);

  return function() { 
    // make a copy of staticArgs (don't modify it because it gets reused for
    // every invocation).
    var args = staticArgs.concat();

    // add all the new arguments
    for (var i = 0; i < arguments.length; i++) {
      args.push(arguments[i]);
    }

    // invoke the original function with the correct this obj and the combined
    // list of static and dynamic arguments.
    return obj[meth].apply(obj, args);
  };
}

function getTempFile() {
		var file = Components.classes["@mozilla.org/file/directory_service;1"]
		.getService(Components.interfaces.nsIProperties)
		.get("TmpD", Components.interfaces.nsILocalFile);

		file.append("mf_" + new Date().getTime());

		return file;
}

function getFileUri(dir, filename){
		var file = dir.clone();
		file.append(filename);
	return Components.classes["@mozilla.org/network/io-service;1"]
                   .getService(Components.interfaces.nsIIOService)
                   .newFileURI(file);
}


/**
 * Logs a message to the console. The message can have python style %s 
 * thingers which will be interpolated with additional parameters passed.
 */
function log(message) {
  logf.apply(null, arguments);
  
}

function logf(message) {
  for (var i = 1; i < arguments.length; i++) {
    message = message.replace(/\%s/, arguments[i]);
  }
  dump(message + "\n");
}

/**
 * Loggifies an object. Every method of the object will have it's entrance, 
 * any parameters, any errors, and it's exit logged automatically.
 */
function loggify(obj, name) {
  for (var p in obj) {
    if (typeof obj[p] == "function") {
      obj[p] = gen_loggify_wrapper(obj[p], name, p);
    }
  }
}

function gen_loggify_wrapper(meth, objName, methName) {
  return function() {
    var retVal;
    var args = new Array(arguments.length);
    for (var i = 0; i < args.length; i++) {
      args[i] = arguments[i];
    }
    
    log("> %s.%s(%s)", objName, methName, args.join(", "));
    
    try {
      return retVal = meth.apply(this, arguments);
    } finally {
      log("< %s.%s: %s", 
          objName, 
          methName, 
          (typeof retVal == "undefined" ? "void" : retVal));
    }
  }
}

function getContents(aURL, charset){
	if( !charset ) {
		charset = "UTF-8"
	}
  var ioService=Components.classes["@mozilla.org/network/io-service;1"]
    .getService(Components.interfaces.nsIIOService);
  var scriptableStream=Components
    .classes["@mozilla.org/scriptableinputstream;1"]
    .getService(Components.interfaces.nsIScriptableInputStream);
  // http://lxr.mozilla.org/mozilla/source/intl/uconv/idl/nsIScriptableUConv.idl
  var unicodeConverter = Components
    .classes["@mozilla.org/intl/scriptableunicodeconverter"]
    .createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
  unicodeConverter.charset = charset;

  var channel=ioService.newChannel(aURL,null,null);
  var input=channel.open();
  scriptableStream.init(input);
  var str=scriptableStream.read(input.available());
  scriptableStream.close();
  input.close();

  try {
    return unicodeConverter.ConvertToUnicode(str);
  } catch( e ) {
    return str;
  }
}
